﻿<AML>
 <Item type="Method" id="4E31892523E44BFAACEC5F25E518883E" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[/* *****************************************************************************
Method Name:		    acc_ar_bank_default
Created By/Company:		SolidCAD
Creation Date:			2018-01-23
Description:
	-Add Property acc_form
	-If do RECEIVE PAYMENT in Bulk Receivable,assign acc_form='acc_accountsreceivable'
	-If do NEW PAYMENT in Payment,assign acc_form='acc_accountpayable'
	
Hooks:
	Type:	Form    :   acc_AccountsReceivable 
	Event:	onLoad
	
	Type:	Form    :   Acc_AccountPayable 
	Event:	onLoad
	
Revisions:
	Rev Date		Modified By			Description
	2018-07-16		Chan			Initial creation
***************************************************************************** */
// debugger;
var myInnovator = new Innovator();
var erp_sale_bank_account = "";
var erp_purchase_bank_account = "";
var erp_company_setup = myInnovator.newItem("erp_company_setup", "get");
var result = erp_company_setup.apply();
var result_count = result.getItemCount();
if (result_count > 0) {
    var setup = result.getItemByIndex(0);
    erp_sale_bank_account = setup.getProperty("erp_sale_bank_account", "");
    erp_purchase_bank_account = setup.getProperty("erp_purchase_bank_account", "");
}
var _id = top.aras.getItemProperty(document.item, 'id');
var acc_date = top.aras.getItemProperty(document.item, 'acc_date');
var itemType = document.thisItem.getType().toString().toLowerCase();
switch (itemType) {
    case 'acc_accountsreceivable':
        {
            handleItemChange("acc_form", "acc_accountsreceivable"); //2018-07-16
            var receivable_item = document.thisItem.newItem("acc_AccountsReceivable", "get");
            receivable_item.setProperty("id", _id);
            receivable_item.setPropertyCondition("id", "eq");
            receivable_item = receivable_item.apply();

            if (receivable_item.getItemCount() <= 0) {
                handleItemChange("acc_cash_account", erp_sale_bank_account);
                if (erp_sale_bank_account !== "") {
                    var acc_accountdetails_qry = myInnovator.newItem("acc_AccountDetails", "get");
                    acc_accountdetails_qry.setProperty("id", erp_sale_bank_account);
                    var acc_accountdetails_qry_result = acc_accountdetails_qry.apply();
                    var acc_accountdetails_qry_count = acc_accountdetails_qry_result.getItemCount();
                    if (acc_accountdetails_qry_count > 0) {
                        var acc_accountdetails_result = acc_accountdetails_qry_result.getItemByIndex(0);
                        var id = acc_accountdetails_result.getProperty("id", "");
                        var acc_currency = acc_accountdetails_qry_result.getProperty("acc_currency", "");
                        var acc_amount = acc_accountdetails_qry_result.getProperty("acc_amount", "");

                        var currency_result = myInnovator.applyMethod("acc_currency_info", "<currency_id>" + acc_currency + "</currency_id><currency_date>" + acc_date + "</currency_date>");

                        var currency_count = currency_result.getItemCount();
                        if (currency_count > 0) {
                            var currency_code = currency_result.getProperty("acc_currencycode", "");
                            handleItemChange("acc_currency", acc_currency);
                            handleItemChange("acc_cash_balance", acc_amount);
                            handleItemChange("acc_rate", currency_result.getProperty("acc_monthly_rate", ""));
                            handleItemChange("acc_operator", currency_result.getProperty("acc_operator", ""));

                            if (currency_result.getProperty("acc_isdefault", "") == "1") {
                                handleItemChange("acc_currency_default", 1);
                            } else {
                                handleItemChange("acc_currency_default", 0);
                            }

                        }
                    }
                }
            }
        }
        break;


    case 'acc_accountpayable':
        {
            handleItemChange("acc_form", "acc_accountpayable"); //2018-07-16
            var payable_item = document.thisItem.newItem("Acc_AccountPayable", "get");
            payable_item.setProperty("id", _id);
            payable_item.setPropertyCondition("id", "eq");
            payable_item = payable_item.apply();

            if (payable_item.getItemCount() <= 0) {
                handleItemChange("acc_cash_account", erp_purchase_bank_account);
                if (erp_sale_bank_account !== "") {
                    var acc_accountdetails_qry = myInnovator.newItem("acc_AccountDetails", "get");
                    acc_accountdetails_qry.setProperty("id", erp_purchase_bank_account);
                    var acc_accountdetails_qry_result = acc_accountdetails_qry.apply();
                    var acc_accountdetails_qry_count = acc_accountdetails_qry_result.getItemCount();
                    if (acc_accountdetails_qry_count > 0) {
                        var acc_accountdetails_result = acc_accountdetails_qry_result.getItemByIndex(0);
                        var id = acc_accountdetails_result.getProperty("id", "");
                        var acc_currency = acc_accountdetails_qry_result.getProperty("acc_currency", "");
                        var acc_amount = acc_accountdetails_qry_result.getProperty("acc_amount", "");
                        
                        var currency_result = myInnovator.applyMethod("acc_currency_info", "<currency_id>" + acc_currency + "</currency_id><currency_date>" + acc_date + "</currency_date>");

                        var currency_count = currency_result.getItemCount();
                        if (currency_count > 0) {
                            var currency_code = currency_result.getProperty("acc_currencycode", "");
                            handleItemChange("acc_currency", acc_currency);
                            handleItemChange("acc_cash_balance", acc_amount);
                            handleItemChange("acc_rate", currency_result.getProperty("acc_monthly_rate", ""));
                            handleItemChange("acc_operator", currency_result.getProperty("acc_operator", ""));

                            if (currency_result.getProperty("acc_isdefault", "") == "1") {
                                handleItemChange("acc_currency_default", 1);
                            } else {
                                handleItemChange("acc_currency_default", 0);
                            }
                        }
                    }
                }
            }
        }
        break;

    default:
}]]></method_code>
  <method_type>JavaScript</method_type>
  <name>acc_ar_bank_default</name>
 </Item>
</AML>